include:
    # copy of https://gitlab.com/Orange-OpenSource/gitlab-buildpkg/-/blob/master/templates/buildpkg.yml
    # This avoids updates on the template to break the build script
    local: "gitlab/templates/buildpkg.yml"

variables:
  CI_PAGES_DOMAIN: gitlab.io
  CI_PAGES_URL: 'https://packages.wikisuite.org'

workflow:
  rules:
    - if: $CI_PIPELINE_SOURCE == "merge_request_event"
    - if: $CI_COMMIT_BRANCH == "main"

stages:
  - build
  - sign
  - merge
  - generate
  - deploy
  - staging
  - production

before_script:
  - unset http_proxy ; unset https_proxy

.build-base:
  parallel:
    matrix:
      - BUILD_IMAGE:
          - "debian:buster" # Debian 10
          - "debian:bullseye" # Debian 11
          - "debian:bookworm" # Debian 12
          - "ubuntu:bionic" # Ubuntu 18.04 LTS
          - "ubuntu:focal" # Ubuntu 20.04 LTS
          - "ubuntu:jammy" # Ubuntu 22.04 LTS
  before_script:
    - bash ${CI_PROJECT_DIR}/gitlab/generate-test-gpg-keys.sh ${CI_PROJECT_DIR}/result main

sign:
  before_script:
    - '[ -z "${GPG_PRIVATE_KEY}" ] && { export GPG_PRIVATE_KEY=$(cat ${CI_PROJECT_DIR}/result/gpgTestKeyFilePriv); export SIGN_USER="WikiSuite Tester"; }'
  rules:

merge:
  image: $REGISTRY/$BUILD_IMAGE
  stage: merge
  script:
    - apt-get update && apt-get install -y unzip
    - bash ${CI_PROJECT_DIR}/gitlab/extract-versions.sh ${CI_PROJECT_DIR}/result
  # - bash -x ${CI_PROJECT_DIR}/gitlab/merge-new-packages.sh ${CI_PROJECT_DIR}/result
  artifacts:
    expire_in: 1 day
    paths:
      - result/*
      - pages.zip

generatePages:
  image: $REGISTRY/$BUILD_IMAGE
  stage: generate
  variables:
    PAGES_HOST: $CI_PAGES_DOMAIN
    GIT_STRATEGY: none
  environment:
    name: PPA
    url: $CI_PAGES_URL
  dependencies:
    - merge
  artifacts:
    paths:
      - public
  script:
    - '[ -z "${GPG_PRIVATE_KEY}" ] && { export GPG_PRIVATE_KEY=$(cat ${CI_PROJECT_DIR}/result/gpgTestKeyFilePriv); export SIGN_USER="WikiSuite Tester"; }'
    - cd "$CI_PROJECT_DIR"
    - apt-get update && apt-get install -y zip
    - echo "$GPG_PRIVATE_KEY" | gpg --import --batch --no-tty --yes - || true
    - gpg --list-secret-keys
    - ci-pages-ppa
    - ci-pages-home
    - ci-pages-tree
    - zip -r public/result.zip result -x "result/.apt/*"

pages:
  script:
    - echo "Pages content already prepared in generatePages, deploying..."
  dependencies:
    - generatePages
  rules:
    - if: $CI_COMMIT_BRANCH == "main"
    - if: $WIKISUITE_PACKAGES_FORCE_RUN_PAGES == "y"
    - if: $CI_PIPELINE_SOURCE == "merge_request_event"
      when: never
    - if: $CI_COMMIT_REF_PROTECTED != "true"
      when: never
    - if: $DEPLOY_MANUAL == "true"
      when: manual
      allow_failure: true
    - when: on_success
